#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include "ShiftRegister.h"
#include "Keypad.h"
#include "Usart.h"

volatile char charReceived[4];

int main()
{

    USART_init(9600);

    HC595Init();
    HC595Init1();
    HC595Init2();

    HC595Write(0b00000000);
    HC595Write1(0b00000000);
    HC595Write2(0b00000000);

    char lastTask = 0;

    while(1) {

      //Daca este timpul sa primim:
      if (lastTask == 1) {

        charReceived[0] = USART_receive();
        charReceived[1] = USART_receive();
        charReceived[2] = USART_receive();

        HC595Write(charReceived[0]);
        HC595Write1(charReceived[1]);
        HC595Write2(charReceived[2]);

        lastTask = 0;
      }
      //Daca este timpul sa trimitem:
      if (lastTask == 0){

        while (1) {

          char c = keyfind();

          if(c == 'A'){

            USART_transmit('A');
            USART_transmit('N');
            break;
          }
          if(c == 'B'){

            USART_transmit('B');
            USART_transmit('N');
            break;
          }
          if(c == 'C'){

            USART_transmit('C');
            USART_transmit('N');
            break;
          }
          if(c == 'D'){

            USART_transmit('D');
            USART_transmit('N');
            break;
          }
          if(c == 'E'){

            USART_transmit('E');
            USART_transmit('N');
            break;
          }
          if(c == 'F'){

            USART_transmit('F');
            USART_transmit('N');
            break;
          }
          if(c == 'G'){

            USART_transmit('G');
            USART_transmit('N');
            break;
          }

          if(c == '1'){

            USART_transmit('H');
            USART_transmit('N');
            break;
          }
          if(c == '2'){

            USART_transmit('I');
            USART_transmit('N');
            break;
          }
          if(c == '3'){

            USART_transmit('J');
            USART_transmit('N');
            break;
          }
          if(c == '4'){

            USART_transmit('K');
            USART_transmit('N');
            break;
          }
          if(c == '5'){

            USART_transmit('L');
            USART_transmit('N');
            break;
          }
          if(c == '6'){

            USART_transmit('M');
            USART_transmit('N');
            break;
          }
          if(c == '7'){

            USART_transmit('Q');
            USART_transmit('N');
            break;
          }
          if(c == '8'){

            USART_transmit('O');
            USART_transmit('N');
            break;
          }
          if(c == '9'){

            USART_transmit('P');
            USART_transmit('N');
            break;
          }
        }

        lastTask = 1;
      }

    }

    return 0;
}
